/*
 * JarnikPrim.h
 *
 *   Created on: Jun 19, 2014
 *       Author: David Rosca
 */

#ifndef GRAPH_JARNIK_PRIM_H_
#define GRAPH_JARNIK_PRIM_H_

#include <core/multipleDispatch.hpp>
#include <graph/GraphClasses.h>

namespace graph {

namespace spanningtree {

class JarnikPrim : public std::SingleDispatchLastStaticParam<JarnikPrim, graph::Graph, graph::GraphBase, const Node&> {
public:
	static Graph jarnikprim(const Graph &graph, const Node &start);

	static AdjacencyListUndirectedGraph jarnikprim(const UndirectedGraph &graph, const Node &start);

};

} // namespace spanningtree

} // namespace graph

#endif // GRAPH_JARNIK_PRIM_H_
