#include "RTE.h"
#include "../alphabet/Symbol.h"
#include "../string/LinearString.h"

#include <XmlApi.hpp>

namespace rte {

const std::set < alphabet::RankedSymbol > & RTE::getAlphabet ( ) const {
	return this->getData ( ).getAlphabet ( );
}

const std::set < alphabet::RankedSymbol > & RTE::getConstantAlphabet ( ) const {
	return this->getData ( ).getConstantAlphabet ( );
}

/*
 * rte::RTE regexpFrom ( const std::string & string ) {
 *  rte::UnboundedRTEConcatenation con;
 *
 *  for ( const char & symbol : string )
 *      con.appendElement ( rte::UnboundedRTESymbol ( alphabet::symbolFrom ( symbol ) ) );
 *
 *  return rte::RTE {
 *             rte::UnboundedRTE ( std::move ( con ) )
 *  };
 * }
 *
 * rte::RTE regexpFrom ( const char * string ) {
 *  return regexpFrom ( ( std::string ) string );
 * }
 *
 * rte::RTE regexpFrom ( string::LinearString string ) {
 *  rte::UnboundedRTEConcatenation con;
 *
 *  for ( auto & symbol : string.getContent ( ) )
 *      con.appendElement ( rte::UnboundedRTESymbol ( std::move ( symbol ) ) );
 *
 *  return rte::RTE {
 *             rte::UnboundedRTE ( std::move ( con ) )
 *  };
 * }
 *
 * rte::RTE regexpFrom ( alphabet::Symbol symbol ) {
 *  return rte::RTE {
 *             rte::UnboundedRTE ( rte::UnboundedRTESymbol ( std::move ( symbol ) ) )
 *  };
 * }
 *
 * rte::RTE regexpFrom ( ) {
 *  return rte::RTE {
 *             rte::UnboundedRTE ( rte::UnboundedRTEEmpty { } )
 *  };
 * }
 */
} /* namespace rte */

namespace alib {

auto RTEDeleter = xmlApi < rte::RTE >::InputContextDeleter ( );
}
