#include "FormalRTEEmpty.h"

// #include "../unbounded/UnboundedRTEEmpty.h"

namespace rte {

FormalRTEEmpty::FormalRTEEmpty ( ) {
	// so that default constructor is available
}

FormalRTEEmpty::FormalRTEEmpty ( const FormalRTEEmpty & ) {
	// so that copy constructor is available
}

FormalRTEEmpty::FormalRTEEmpty ( FormalRTEEmpty && ) noexcept {
	this->attachRTE ( NULL );
}

FormalRTEEmpty & FormalRTEEmpty::operator =( const FormalRTEEmpty & ) {
	 // this is actually different than default implementation
	return * this;
}

FormalRTEEmpty & FormalRTEEmpty::operator =( FormalRTEEmpty && ) noexcept {
	 // this is actually different than default implementation
	return * this;
}

FormalRTEEmpty * FormalRTEEmpty::clone ( ) const {
	return new FormalRTEEmpty ( * this );
}

FormalRTEEmpty * FormalRTEEmpty::plunder ( ) && {
	return new FormalRTEEmpty ( std::move ( * this ) );
}

/*
 * UnboundedRTEElement* FormalRTEEmpty::cloneAsUnbounded() const {
 *  return new UnboundedRTEEmpty();
 * }
 */
int FormalRTEEmpty::compare ( const FormalRTEEmpty & ) const {
	return 0;
}

void FormalRTEEmpty::operator >>( std::ostream & out ) const {
	out << "(FormalRTEEmpty)";
}

bool FormalRTEEmpty::testSymbol ( const alphabet::RankedSymbol & ) const {
	return false;
}

bool FormalRTEEmpty::attachRTE ( const FormalRTE * regexp ) {
	if ( this->parentRTE == regexp ) return true;

	this->parentRTE = regexp;
	return true;
}

void FormalRTEEmpty::computeMinimalAlphabet ( std::set < alphabet::RankedSymbol > & /*alphabetF*/, std::set < alphabet::RankedSymbol > & /*alphabetK*/ ) const {
}

FormalRTEEmpty::operator std::string ( ) const {
	std::stringstream ss;
	ss << * this;
	return ss.str ( );
}

} /* namespace rte */
