#ifndef ISOMORPHISM_TEST_H_
#define ISOMORPHISM_TEST_H_

#include <cppunit/extensions/HelperMacros.h>

class GraphIsomorphismTest : public CppUnit::TestFixture
{
	CPPUNIT_TEST_SUITE(GraphIsomorphismTest);
	CPPUNIT_TEST(testSameGraphs);
	CPPUNIT_TEST(testIsomorphicGraphs);
	CPPUNIT_TEST_SUITE_END();

public:
	void testSameGraphs();
	void testIsomorphicGraphs();
};

#endif // HOPCROFT_TEST_H_
