/*
 * StringToXMLComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef STRING_TO_XML_COMPOSER_H_
#define STRING_TO_XML_COMPOSER_H_

#include <deque>
#include <sax/Token.h>
#include <set>
#include <vector>
#include "../../alphabet/Symbol.h"

namespace string {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class StringToXMLComposer {
public:
	static void compose(std::deque<sax::Token>& out, const std::set<alphabet::Symbol>& alphabet);
	static void compose(std::deque<sax::Token>& out, const std::vector<alphabet::Symbol>& content);
};

} /* namespace string */

#endif /* STRING_TO_XML_COMPOSER_H_ */
