/*
 * StringFromRawParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_RAW_PARSER
#define STRING_FROM_RAW_PARSER

#include <iterator>
#include <set>
#include <string/StringFeatures.h>

namespace string {

class StringFromRawParser {
public:
	StringFromRawParser() {}

	String parseString(std::istream_iterator<char>& input) const;
	String parseString(std::istream_iterator<char>& input, const std::set<FEATURES>& features) const;

};

} /* namespace string */

#endif /* STRING_FROM_RAW_PARSER */
