/*
 * SetStat.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "SetStat.h"
#include "common/Printer.hpp"

void SetStat::stat ( const container::ObjectsSet & data, const SetSettings & settings ) {
	Printer::PrintSet ( settings.general, data );
}

void SetStat::stat ( const label::LabelSetLabel & data, const SetSettings & settings ) {
	Printer::PrintSet ( settings.general, data.getData ( ) );
}

void SetStat::stat ( const alphabet::SymbolSetSymbol & data, const SetSettings & settings ) {
	Printer::PrintSet ( settings.general, data.getData ( ) );
}
